Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsed.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsed.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsed.F90	(revision 2819)
@@ -15,16 +15,13 @@
    !!   p4z_sed_init   :  Initialization of p4z_sed
    !!----------------------------------------------------------------------
-   USE trc
-   USE oce_trc         !
-   USE sms_pisces
-   USE prtctl_trc
-   USE p4zbio
-   USE p4zint
-   USE p4zopt
-   USE p4zsink
-   USE p4zrem
-   USE p4zlim
-   USE iom
-
+   USE oce_trc         !  shared variables between ocean and passive tracers
+   USE trc             !  passive tracers common variables 
+   USE sms_pisces      !  PISCES Source Minus Sink variables
+   USE p4zsink         !  vertical flux of particulate matter due to sinking
+   USE p4zopt          !  optical model
+   USE p4zlim          !  Co-limitations of differents nutrients
+   USE p4zrem          !  Remineralisation of organic matter
+   USE prtctl_trc      !  print control for debugging
+   USE iom             !  I/O manager
 
    IMPLICIT NONE
@@ -247,9 +244,9 @@
                IF( zlim <= 0.2 )   zlim = 0.01
                znitrpot(ji,jj,jk) = MAX( 0.e0, ( 0.6 * tgfunc(ji,jj,jk) - 2.15 ) * rday1 )   &
+                  &                  * zlim * rfact2 * trn(ji,jj,jk,jpfer)   &
 # if defined key_degrad
-               &                  * facvol(ji,jj,jk)   &
+                  &                  * facvol(ji,jj,jk)
 # endif
-               &                  * zlim * rfact2 * trn(ji,jj,jk,jpfer)   &
-               &                  / ( conc3 + trn(ji,jj,jk,jpfer) ) * ( 1.- EXP( -etot(ji,jj,jk) / 50.) )
+                  &                  / ( conc3 + trn(ji,jj,jk,jpfer) ) * ( 1.- EXP( -etot(ji,jj,jk) / 50.) )
             END DO
          END DO 
@@ -272,18 +269,19 @@
       END DO
 
-#if defined key_diatrc
-      zfact = 1.e+3 * rfact2r
-#  if  ! defined key_iomput
-      trc2d(:,:,jp_pcs0_2d + 11) = zirondep(:,:,1)         * zfact * fse3t(:,:,1) * tmask(:,:,1)
-      trc2d(:,:,jp_pcs0_2d + 12) = znitrpot(:,:,1) * 1.e-7 * zfact * fse3t(:,:,1) * tmask(:,:,1)
-#  else
-      zwork (:,:)  =  ( zirondep(:,:,1) + ironsed(:,:,1) * rfact2 ) * zfact * fse3t(:,:,1) * tmask(:,:,1) 
-      zwork1(:,:)  =  znitrpot(:,:,1) * 1.e-7                       * zfact * fse3t(:,:,1) * tmask(:,:,1)
-      IF( jnt == nrdttrc ) THEN
-         CALL iom_put( "Irondep", zwork  )  ! surface downward net flux of iron
-         CALL iom_put( "Nfix"   , zwork1 )  ! nitrogen fixation at surface
+      IF( ln_diatrc ) THEN
+         !
+         zfact = 1.e+3 * rfact2r
+         zwork (:,:)  =  ( zirondep(:,:,1) + ironsed(:,:,1) * rfact2 ) * zfact * fse3t(:,:,1) * tmask(:,:,1) 
+         zwork1(:,:)  =    znitrpot(:,:,1) * 1.e-7                     * zfact * fse3t(:,:,1) * tmask(:,:,1)
+         IF( jnt == nrdttrc ) THEN
+            CALL iom_put( "Irondep", zwork  )  ! surface downward net flux of iron
+            CALL iom_put( "Nfix"   , zwork1 )  ! nitrogen fixation at surface
+         ENDIF
+# if ! defined key_iomput
+         trc2d(:,:,jp_pcs0_2d + 11) = zirondep(:,:,1)         * zfact * fse3t(:,:,1) * tmask(:,:,1)
+         trc2d(:,:,jp_pcs0_2d + 12) = znitrpot(:,:,1) * 1.e-7 * zfact * fse3t(:,:,1) * tmask(:,:,1)
+# endif
+         !
       ENDIF
-#  endif
-#endif
       !
        IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
@@ -355,5 +353,4 @@
 
    END SUBROUTINE p4z_sbc
-
 
    SUBROUTINE p4z_sed_init
@@ -385,7 +382,7 @@
          CALL ctl_stop('p4z_sed_init: requested workspace arrays unavailable')  ;  RETURN
       END IF
-      !
-      REWIND( numnat )                     ! read numnat
-      READ  ( numnat, nampissed )
+
+      REWIND( numnatp )                     ! read numnatp
+      READ  ( numnatp, nampissed )
 
       IF(lwp) THEN
Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsink.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsink.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsink.F90	(revision 2819)
@@ -2,5 +2,5 @@
    !!======================================================================
    !!                         ***  MODULE p4zsink  ***
-   !! TOP :   PISCES Compute vertical flux of particulate matter due to gravitational sinking
+   !! TOP :  PISCES  vertical flux of particulate matter due to gravitational sinking
    !!======================================================================
    !! History :   1.0  !  2004     (O. Aumont) Original code
@@ -9,10 +9,12 @@
    !!----------------------------------------------------------------------
    !!   p4z_sink       :  Compute vertical flux of particulate matter due to gravitational sinking
+   !!   p4z_sink_init  :  Unitialisation of sinking speed parameters
+   !!   p4z_sink_alloc :  Allocate sinking speed variables
    !!----------------------------------------------------------------------
-   USE trc
-   USE oce_trc         !
-   USE sms_pisces
-   USE prtctl_trc
-   USE iom
+   USE oce_trc         !  shared variables between ocean and passive tracers
+   USE trc             !  passive tracers common variables 
+   USE sms_pisces      !  PISCES Source Minus Sink variables
+   USE prtctl_trc      !  print control for debugging
+   USE iom             !  I/O manager
 
    IMPLICIT NONE
@@ -91,8 +93,6 @@
       REAL(wp) :: zdiv , zdiv1, zdiv2, zdiv3, zdiv4, zdiv5
       REAL(wp) :: zval1, zval2, zval3, zval4
-#if defined key_diatrc
       REAL(wp) :: zrfact2
       INTEGER  :: ik1
-#endif
       CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
@@ -193,9 +193,5 @@
                      &            * (zeps-1)/zdiv1 + 3.*(zfm*xkr_mass_max-xkr_mass_min)    &
                      &            * (zfm*xkr_mass_max**2-xkr_mass_min**2)                  &
-                     &            * (zeps-1.)**2/(zdiv2*zdiv3))            &
-# if defined key_degrad
-                     &                 *facvol(ji,jj,jk)       &
-# endif
-                     &    )
+                     &            * (zeps-1.)**2/(zdiv2*zdiv3))           ) 
 
                   zagg2 = (  2*0.163*trn(ji,jj,jk,jpnum)**2*zfm*                       &
@@ -205,16 +201,13 @@
                      &                    +xkr_mass_min**3*(zeps-1)/zdiv1)                  &
                      &                    -zfm*xkr_mass_max**3*(1.+3.*((zeps-1.)/           &
-                     &                    (zeps-2.)+(zeps-1.)/zdiv3)+(zeps-1.)/zdiv1))      &
-#    if defined key_degrad
-                     &                 *facvol(ji,jj,jk)             &
-#    endif
-                     &    )
-
-                  zagg3 = (  0.163*trn(ji,jj,jk,jpnum)**2*zfm**2*8. * xkr_mass_max**3   &
-#    if defined key_degrad
-                     &                 *facvol(ji,jj,jk)             &
-#    endif
-                     &    )
-
+                     &                    (zeps-2.)+(zeps-1.)/zdiv3)+(zeps-1.)/zdiv1))  ) 
+
+                  zagg3 = (  0.163*trn(ji,jj,jk,jpnum)**2*zfm**2*8. * xkr_mass_max**3 ) 
+
+                  IF( lk_degrad ) THEN
+                     zagg1 = zagg1 * facvol(ji,jj,jk)
+                     zagg2 = zagg2 * facvol(ji,jj,jk)
+                     zagg3 = zagg3 * facvol(ji,jj,jk)
+                  ENDIF
                   zaggsh = ( zagg1 + zagg2 + zagg3 ) * rfact2 * xdiss(ji,jj,jk) / 1000.
 
@@ -228,9 +221,5 @@
                      &                 -(1.-zfm)/(zdiv*(zeps-1.)))-                       &
                      &                 ((zfm*zfm*xkr_mass_max**2*zsm-xkr_mass_min**2)     &
-                     &                 *xkr_eta)/(zdiv*zdiv3*zdiv5) )                     &
-# if defined key_degrad
-                     &                 *facvol(ji,jj,jk)        &
-# endif
-                     &    )
+                     &                 *xkr_eta)/(zdiv*zdiv3*zdiv5) )  ) 
 
                   zagg5 = (  2.*3.141*0.125*trn(ji,jj,jk,jpnum)**2                         &
@@ -238,10 +227,9 @@
                      &                 *(zsm*(xkr_mass_min**2-zfm*xkr_mass_max**2)         &
                      &                 /zdiv3-(xkr_mass_min**2-zfm*zsm*xkr_mass_max**2)    &
-                     &                 /zdiv)                   &
+                     &                 /zdiv)    ) 
 # if defined key_degrad
-                     &                 *facvol(ji,jj,jk)        &
+                  zagg4 = zagg4 * facvol(ji,jj,jk)
+                  zagg5 = zagg5 * facvol(ji,jj,jk)
 # endif
-                     &    )
-
                   zaggsi = ( zagg4 + zagg5 ) * xstep / 10.
 
@@ -254,5 +242,5 @@
                      &        + 1018.  * trn(ji,jj,jk,jppoc)  ) * xstep    &
 # if defined key_degrad
-                     &        * facvol(ji,jj,jk)                              &
+                     &        * facvol(ji,jj,jk)
 # endif
                      &        * xdiss(ji,jj,jk) * trn(ji,jj,jk,jpdoc)
@@ -268,38 +256,38 @@
       END DO
 
-#if defined key_diatrc
-      zrfact2 = 1.e3 * rfact2r
-      ik1 = iksed + 1
-#  if ! defined key_iomput
-      trc2d(:,:  ,jp_pcs0_2d + 4)  = sinking (:,:,ik1) * zrfact2 * tmask(:,:,1)
-      trc2d(:,:  ,jp_pcs0_2d + 5)  = sinking2(:,:,ik1) * zrfact2 * tmask(:,:,1)
-      trc2d(:,:  ,jp_pcs0_2d + 6)  = sinkfer (:,:,ik1) * zrfact2 * tmask(:,:,1)
-      trc2d(:,:  ,jp_pcs0_2d + 7)  = sinksil (:,:,ik1) * zrfact2 * tmask(:,:,1)
-      trc2d(:,:  ,jp_pcs0_2d + 8)  = sinkcal (:,:,ik1) * zrfact2 * tmask(:,:,1)
-      trc3d(:,:,:,jp_pcs0_3d + 11) = sinking (:,:,:)      * zrfact2 * tmask(:,:,:)
-      trc3d(:,:,:,jp_pcs0_3d + 12) = sinking2(:,:,:)      * zrfact2 * tmask(:,:,:)
-      trc3d(:,:,:,jp_pcs0_3d + 13) = sinksil (:,:,:)      * zrfact2 * tmask(:,:,:)
-      trc3d(:,:,:,jp_pcs0_3d + 14) = sinkcal (:,:,:)      * zrfact2 * tmask(:,:,:)
-      trc3d(:,:,:,jp_pcs0_3d + 15) = znum3d  (:,:,:)                * tmask(:,:,:)
-      trc3d(:,:,:,jp_pcs0_3d + 16) = wsbio3  (:,:,:)                * tmask(:,:,:)
-      trc3d(:,:,:,jp_pcs0_3d + 17) = wsbio4  (:,:,:)                * tmask(:,:,:)
-#else
-      IF( jnt == nrdttrc ) then
-        CALL iom_put( "POCFlx"  , sinking (:,:,:)      * zrfact2 * tmask(:,:,:) )  ! POC export
-        CALL iom_put( "NumFlx"  , sinking2 (:,:,:)     * zrfact2 * tmask(:,:,:) )  ! Num export
-        CALL iom_put( "SiFlx"   , sinksil (:,:,:)      * zrfact2 * tmask(:,:,:) )  ! Silica export
-        CALL iom_put( "CaCO3Flx", sinkcal (:,:,:)      * zrfact2 * tmask(:,:,:) )  ! Calcite export
-        CALL iom_put( "xnum"    , znum3d  (:,:,:)                * tmask(:,:,:) )  ! Number of particles in aggregats
-        CALL iom_put( "W1"      , wsbio3  (:,:,:)                * tmask(:,:,:) )  ! sinking speed of POC
-        CALL iom_put( "W2"      , wsbio4  (:,:,:)                * tmask(:,:,:) )  ! sinking speed of aggregats
-        CALL iom_put( "PMO"     , sinking (:,:,ik1) * zrfact2 * tmask(:,:,1) )  ! POC export at 100m
-        CALL iom_put( "PMO2"    , sinking2(:,:,ik1) * zrfact2 * tmask(:,:,1) )  ! Num export at 100m
-        CALL iom_put( "ExpFe1"  , sinkfer (:,:,ik1) * zrfact2 * tmask(:,:,1) )  ! Export of iron at 100m
-        CALL iom_put( "ExpSi"   , sinksil (:,:,ik1) * zrfact2 * tmask(:,:,1) )  ! export of silica at 100m
-        CALL iom_put( "ExpCaCO3", sinkcal (:,:,ik1) * zrfact2 * tmask(:,:,1) )  ! export of calcite at 100m
-     ENDIF
-#  endif
-
-#endif
+      IF( ln_diatrc ) THEN
+         !
+         ik1 = iksed + 1
+         zrfact2 = 1.e3 * rfact2r
+         IF( jnt == nrdttrc ) THEN
+           CALL iom_put( "POCFlx"  , sinking (:,:,:)      * zrfact2 * tmask(:,:,:) )  ! POC export
+           CALL iom_put( "NumFlx"  , sinking2 (:,:,:)     * zrfact2 * tmask(:,:,:) )  ! Num export
+           CALL iom_put( "SiFlx"   , sinksil (:,:,:)      * zrfact2 * tmask(:,:,:) )  ! Silica export
+           CALL iom_put( "CaCO3Flx", sinkcal (:,:,:)      * zrfact2 * tmask(:,:,:) )  ! Calcite export
+           CALL iom_put( "xnum"    , znum3d  (:,:,:)                * tmask(:,:,:) )  ! Number of particles in aggregats
+           CALL iom_put( "W1"      , wsbio3  (:,:,:)                * tmask(:,:,:) )  ! sinking speed of POC
+           CALL iom_put( "W2"      , wsbio4  (:,:,:)                * tmask(:,:,:) )  ! sinking speed of aggregats
+           CALL iom_put( "PMO"     , sinking (:,:,ik1)    * zrfact2 * tmask(:,:,1) )  ! POC export at 100m
+           CALL iom_put( "PMO2"    , sinking2(:,:,ik1)    * zrfact2 * tmask(:,:,1) )  ! Num export at 100m
+           CALL iom_put( "ExpFe1"  , sinkfer (:,:,ik1)    * zrfact2 * tmask(:,:,1) )  ! Export of iron at 100m
+           CALL iom_put( "ExpSi"   , sinksil (:,:,ik1)    * zrfact2 * tmask(:,:,1) )  ! export of silica at 100m
+           CALL iom_put( "ExpCaCO3", sinkcal (:,:,ik1)    * zrfact2 * tmask(:,:,1) )  ! export of calcite at 100m
+         ENDIF
+# if ! defined key_iomput
+         trc2d(:,:  ,jp_pcs0_2d + 4)  = sinking (:,:,ik1)    * zrfact2 * tmask(:,:,1)
+         trc2d(:,:  ,jp_pcs0_2d + 5)  = sinking2(:,:,ik1)    * zrfact2 * tmask(:,:,1)
+         trc2d(:,:  ,jp_pcs0_2d + 6)  = sinkfer (:,:,ik1)    * zrfact2 * tmask(:,:,1)
+         trc2d(:,:  ,jp_pcs0_2d + 7)  = sinksil (:,:,ik1)    * zrfact2 * tmask(:,:,1)
+         trc2d(:,:  ,jp_pcs0_2d + 8)  = sinkcal (:,:,ik1)    * zrfact2 * tmask(:,:,1)
+         trc3d(:,:,:,jp_pcs0_3d + 11) = sinking (:,:,:)      * zrfact2 * tmask(:,:,:)
+         trc3d(:,:,:,jp_pcs0_3d + 12) = sinking2(:,:,:)      * zrfact2 * tmask(:,:,:)
+         trc3d(:,:,:,jp_pcs0_3d + 13) = sinksil (:,:,:)      * zrfact2 * tmask(:,:,:)
+         trc3d(:,:,:,jp_pcs0_3d + 14) = sinkcal (:,:,:)      * zrfact2 * tmask(:,:,:)
+         trc3d(:,:,:,jp_pcs0_3d + 15) = znum3d  (:,:,:)                * tmask(:,:,:)
+         trc3d(:,:,:,jp_pcs0_3d + 16) = wsbio3  (:,:,:)                * tmask(:,:,:)
+         trc3d(:,:,:,jp_pcs0_3d + 17) = wsbio4  (:,:,:)                * tmask(:,:,:)
+# endif
+        !
+      ENDIF
       !
       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
@@ -335,6 +323,6 @@
       !!----------------------------------------------------------------------
       !
-      REWIND( numnat )                     ! read nampiskrs
-      READ  ( numnat, nampiskrs )
+      REWIND( numnatp )                     ! read nampiskrs
+      READ  ( numnatp, nampiskrs )
 
       IF(lwp) THEN
@@ -459,8 +447,6 @@
       REAL(wp) ::   zagg , zaggfe, zaggdoc, zaggdoc2
       REAL(wp) ::   zfact, zwsmax, zstep
-#if defined key_diatrc
       REAL(wp) ::   zrfact2
       INTEGER  ::   ik1
-#endif
       CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
@@ -526,8 +512,8 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
+               !
+               zstep = xstep 
 # if defined key_degrad
-               zstep = xstep * facvol(ji,jj,jk)
-# else
-               zstep = xstep 
+               zstep = zstep * facvol(ji,jj,jk)
 # endif
                zfact = zstep * xdiss(ji,jj,jk)
@@ -560,23 +546,24 @@
       END DO
 
-#if defined key_diatrc
-      zrfact2 = 1.e3 * rfact2r
-      ik1  = iksed + 1
-#  if ! defined key_iomput
-      trc2d(:,:,jp_pcs0_2d + 4) = sinking (:,:,ik1) * zrfact2 * tmask(:,:,1)
-      trc2d(:,:,jp_pcs0_2d + 5) = sinking2(:,:,ik1) * zrfact2 * tmask(:,:,1)
-      trc2d(:,:,jp_pcs0_2d + 6) = sinkfer (:,:,ik1) * zrfact2 * tmask(:,:,1)
-      trc2d(:,:,jp_pcs0_2d + 7) = sinkfer2(:,:,ik1) * zrfact2 * tmask(:,:,1)
-      trc2d(:,:,jp_pcs0_2d + 8) = sinksil (:,:,ik1) * zrfact2 * tmask(:,:,1)
-      trc2d(:,:,jp_pcs0_2d + 9) = sinkcal (:,:,ik1) * zrfact2 * tmask(:,:,1)
-#  else
-      IF( jnt == nrdttrc )  then
-         CALL iom_put( "EPC100"  , ( sinking(:,:,ik1) + sinking2(:,:,ik1) ) * zrfact2 * tmask(:,:,1) ) ! Export of carbon at 100m
-         CALL iom_put( "EPFE100" , ( sinkfer(:,:,ik1) + sinkfer2(:,:,ik1) ) * zrfact2 * tmask(:,:,1) ) ! Export of iron at 100m
-         CALL iom_put( "EPCAL100",   sinkcal(:,:,ik1)                       * zrfact2 * tmask(:,:,1) ) ! Export of calcite  at 100m
-         CALL iom_put( "EPSI100" ,   sinksil(:,:,ik1)                       * zrfact2 * tmask(:,:,1) ) ! Export of biogenic silica at 100m
+      IF( ln_diatrc ) THEN
+         !
+         zrfact2 = 1.e3 * rfact2r
+         ik1  = iksed + 1
+         IF( jnt == nrdttrc ) THEN
+            CALL iom_put( "EPC100"  , ( sinking(:,:,ik1) + sinking2(:,:,ik1) ) * zrfact2 * tmask(:,:,1) ) ! Export of carbon at 100m
+            CALL iom_put( "EPFE100" , ( sinkfer(:,:,ik1) + sinkfer2(:,:,ik1) ) * zrfact2 * tmask(:,:,1) ) ! Export of iron at 100m
+            CALL iom_put( "EPCAL100",   sinkcal(:,:,ik1)                       * zrfact2 * tmask(:,:,1) ) ! Export of calcite  at 100m
+            CALL iom_put( "EPSI100" ,   sinksil(:,:,ik1)                       * zrfact2 * tmask(:,:,1) ) ! Export of biogenic silica at 100m
+         ENDIF
+# if ! defined key_iomput
+         trc2d(:,:,jp_pcs0_2d + 4) = sinking (:,:,ik1) * zrfact2 * tmask(:,:,1)
+         trc2d(:,:,jp_pcs0_2d + 5) = sinking2(:,:,ik1) * zrfact2 * tmask(:,:,1)
+         trc2d(:,:,jp_pcs0_2d + 6) = sinkfer (:,:,ik1) * zrfact2 * tmask(:,:,1)
+         trc2d(:,:,jp_pcs0_2d + 7) = sinkfer2(:,:,ik1) * zrfact2 * tmask(:,:,1)
+         trc2d(:,:,jp_pcs0_2d + 8) = sinksil (:,:,ik1) * zrfact2 * tmask(:,:,1)
+         trc2d(:,:,jp_pcs0_2d + 9) = sinkcal (:,:,ik1) * zrfact2 * tmask(:,:,1)
+# endif
+         !
       ENDIF
-#endif
-#endif
       !
       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
@@ -630,11 +617,10 @@
 
       DO jk = 1, jpkm1
-# if defined key_degrad
-         zwsink2(:,:,jk+1) = -pwsink(:,:,jk) / rday * tmask(:,:,jk+1) * facvol(:,:,jk)
-# else
-         zwsink2(:,:,jk+1) = -pwsink(:,:,jk) / rday * tmask(:,:,jk+1)
-# endif
+         zwsink2(:,:,jk+1) = -pwsink(:,:,jk) / rday * tmask(:,:,jk+1) 
       END DO
       zwsink2(:,:,1) = 0.e0
+      IF( lk_degrad ) THEN
+         zwsink2(:,:,:) = zwsink2(:,:,:) * facvol(:,:,:)
+      ENDIF
 
 
Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/par_pisces.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/par_pisces.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/par_pisces.F90	(revision 2819)
@@ -29,6 +29,6 @@
    LOGICAL, PUBLIC, PARAMETER ::   lk_kriest     = .TRUE.  !: Kriest flag 
    INTEGER, PUBLIC, PARAMETER ::   jp_pisces     =  23     !: number of passive tracers
-   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_2d  =  13     !: additional 2d output ('key_diatrc')
-   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_3d  =  18     !: additional 3d output ('key_diatrc')
+   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_2d  =  13     !: additional 2d output 
+   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_3d  =  18     !: additional 3d output 
    INTEGER, PUBLIC, PARAMETER ::   jp_pisces_trd =   1     !: number of sms trends for PISCES
 
@@ -67,6 +67,6 @@
    LOGICAL, PUBLIC, PARAMETER ::   lk_kriest     = .FALSE. !: Kriest flag 
    INTEGER, PUBLIC, PARAMETER ::   jp_pisces     = 24      !: number of PISCES passive tracers
-   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_2d  = 13      !: additional 2d output ('key_diatrc')
-   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_3d  = 11      !: additional 3d output ('key_diatrc')
+   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_2d  = 13      !: additional 2d output 
+   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_3d  = 11      !: additional 3d output 
    INTEGER, PUBLIC, PARAMETER ::   jp_pisces_trd =  1      !: number of sms trends for PISCES
 
Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/sms_pisces.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/sms_pisces.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/sms_pisces.F90	(revision 2819)
@@ -16,4 +16,6 @@
    IMPLICIT NONE
    PUBLIC
+
+   INTEGER ::   numnatp
 
    !!*  Time variables
@@ -61,8 +63,6 @@
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   xlimbac    !: ??
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   xdiss      !: ??
-#if defined key_diatrc
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   prodcal    !: Calcite production
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   grazing    !: Total zooplankton grazing
-#endif
 
    !!* Variable for chemistry of the CO2 cycle
@@ -74,4 +74,8 @@
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   borat      !: ???
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   hi         !: ???
+
+   !!* Temperature dependancy of SMS terms
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   tgfunc    !: Temp. dependancy of various biological rates
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   tgfunc2   !: Temp. dependancy of mesozooplankton rates
 
    !!* Array used to indicate negative tracer values
@@ -98,32 +102,33 @@
       !!----------------------------------------------------------------------
       USE lib_mpp , ONLY: ctl_warn
-      INTEGER ::   ierr(5)        ! Local variables
+      INTEGER ::   ierr(6)        ! Local variables
       !!----------------------------------------------------------------------
       ierr(:) = 0
       !
       !*  Biological fluxes for light
-      ALLOCATE( neln(jpi,jpj), heup(jpi,jpj),                           STAT=ierr(1) )
+      ALLOCATE( neln(jpi,jpj), heup(jpi,jpj),                   STAT=ierr(1) )
       !
       !*  Biological fluxes for primary production
-      ALLOCATE( xksimax(jpi,jpj)     , xksi(jpi,jpj)        ,               &
-         &      xnanono3(jpi,jpj,jpk), xdiatno3(jpi,jpj,jpk),               &
-         &      xnanonh4(jpi,jpj,jpk), xdiatnh4(jpi,jpj,jpk),               &
-         &      xlimphy (jpi,jpj,jpk), xlimdia (jpi,jpj,jpk),               &
-         &      concdfe (jpi,jpj,jpk), concnfe (jpi,jpj,jpk),           STAT=ierr(2) ) 
+      ALLOCATE( xksimax(jpi,jpj)     , xksi(jpi,jpj)        ,       &
+         &      xnanono3(jpi,jpj,jpk), xdiatno3(jpi,jpj,jpk),       &
+         &      xnanonh4(jpi,jpj,jpk), xdiatnh4(jpi,jpj,jpk),       &
+         &      xlimphy (jpi,jpj,jpk), xlimdia (jpi,jpj,jpk),       &
+         &      concdfe (jpi,jpj,jpk), concnfe (jpi,jpj,jpk),   STAT=ierr(2) ) 
          !
       !*  SMS for the organic matter
-      ALLOCATE( xfracal (jpi,jpj,jpk), nitrfac (jpi,jpj,jpk),               &
-#if defined key_diatrc
-         &      prodcal(jpi,jpj,jpk) , grazing(jpi,jpj,jpk) ,               &
-#endif 
-         &      xlimbac (jpi,jpj,jpk), xdiss(jpi,jpj,jpk)   ,           STAT=ierr(3) )  
+      ALLOCATE( xfracal (jpi,jpj,jpk), nitrfac (jpi,jpj,jpk),       &
+         &      xlimbac (jpi,jpj,jpk), xdiss(jpi,jpj,jpk)   ,   STAT=ierr(3) )  
          !
       !* Variable for chemistry of the CO2 cycle
-      ALLOCATE( akb3(jpi,jpj,jpk), ak13(jpi,jpj,jpk) ,                      &
-         &      ak23(jpi,jpj,jpk), aksp(jpi,jpj,jpk) ,                      &
-         &      akw3(jpi,jpj,jpk), borat(jpi,jpj,jpk), hi(jpi,jpj,jpk), STAT=ierr(4) )
+      ALLOCATE( akb3(jpi,jpj,jpk)    , ak13(jpi,jpj,jpk)    ,       &
+         &      ak23(jpi,jpj,jpk)    , aksp(jpi,jpj,jpk)    ,       &
+         &      akw3(jpi,jpj,jpk)    , borat(jpi,jpj,jpk)   ,       &
+         &      hi  (jpi,jpj,jpk)    ,                          STAT=ierr(4) )
+         !
+      !* Temperature dependancy of SMS terms
+      ALLOCATE( tgfunc(jpi,jpj,jpk)  , tgfunc2(jpi,jpj,jpk) ,   STAT=ierr(5) )
          !
       !* Array used to indicate negative tracer values  
-      ALLOCATE( xnegtr(jpi,jpj,jpk),                                    STAT=ierr(5) )
+      ALLOCATE( xnegtr(jpi,jpj,jpk)  ,                          STAT=ierr(6) )
       !
       sms_pisces_alloc = MAXVAL( ierr )
Index: /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/trcini_pisces.F90
===================================================================
--- /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/trcini_pisces.F90	(revision 2818)
+++ /branches/2011/dev_r2787_LOCEAN3_TRA_TRP/NEMOGCM/NEMO/TOP_SRC/PISCES/trcini_pisces.F90	(revision 2819)
@@ -17,15 +17,13 @@
    !!----------------------------------------------------------------------
    USE par_trc         ! TOP parameters
-   USE sms_pisces      ! Source Minus Sink variables
-   USE trc
-   USE oce_trc         ! ocean variables
-   USE p4zche 
-   USE p4zche          ! 
-   USE p4zsink         ! 
-   USE p4zopt          ! 
-   USE p4zprod         !
-   USE p4zrem          ! 
-   USE p4zsed          ! 
-   USE p4zflx          ! 
+   USE oce_trc         !  shared variables between ocean and passive tracers
+   USE trc             !  passive tracers common variables 
+   USE sms_pisces      !  PISCES Source Minus Sink variables
+   USE p4zche          !  Chemical model
+   USE p4zsink         !  vertical flux of particulate matter due to sinking
+   USE p4zopt          !  optical model
+   USE p4zrem          !  Remineralisation of organic matter
+   USE p4zflx          !  Gas exchange
+   USE p4zsed          !  Sedimentation
 
    IMPLICIT NONE
@@ -136,11 +134,12 @@
       !! ** Purpose :   Allocate all the dynamic arrays of PISCES 
       !!----------------------------------------------------------------------
-      USE p4zint , ONLY : p4z_int_alloc      
-      USE p4zsink, ONLY : p4z_sink_alloc      
-      USE p4zopt , ONLY : p4z_opt_alloc           
-      USE p4zprod, ONLY : p4z_prod_alloc         
-      USE p4zrem , ONLY : p4z_rem_alloc           
-      USE p4zsed , ONLY : p4z_sed_alloc          
-      USE p4zflx , ONLY : p4z_flx_alloc
+      USE p4zsink , ONLY : p4z_sink_alloc      
+      USE p4zopt  , ONLY : p4z_opt_alloc           
+      USE p4zprod , ONLY : p4z_prod_alloc         
+      USE p4zmort , ONLY : p4z_mort_alloc         
+      USE p4zmicro, ONLY : p4z_micro_alloc         
+      USE p4zrem  , ONLY : p4z_rem_alloc           
+      USE p4zsed  , ONLY : p4z_sed_alloc          
+      USE p4zflx  , ONLY : p4z_flx_alloc
       !
       INTEGER :: ierr
@@ -148,12 +147,13 @@
       !
       ierr =         sms_pisces_alloc()          ! Start of PISCES-related alloc routines...
-      ierr = ierr +     p4z_che_alloc()
-      ierr = ierr +     p4z_int_alloc()
-      ierr = ierr +    p4z_sink_alloc()
-      ierr = ierr +     p4z_opt_alloc()
-      ierr = ierr +    p4z_prod_alloc()
-      ierr = ierr +     p4z_rem_alloc()
-      ierr = ierr +     p4z_sed_alloc()
-      ierr = ierr +     p4z_flx_alloc()
+      ierr = ierr +  p4z_che_alloc()
+      ierr = ierr +  p4z_sink_alloc()
+      ierr = ierr +  p4z_opt_alloc()
+      ierr = ierr +  p4z_prod_alloc()
+      ierr = ierr +  p4z_mort_alloc()
+      ierr = ierr +  p4z_micro_alloc()
+      ierr = ierr +  p4z_rem_alloc()
+      ierr = ierr +  p4z_sed_alloc()
+      ierr = ierr +  p4z_flx_alloc()
       !
       IF( lk_mpp    )   CALL mpp_sum( ierr )
